local utils = require "utils"

--=========================================================
-- 体力ゲージ
--=========================================================
Gauge = {}
Gauge.new = function ()
	
	local this = {}
	
	this.x = 320
	this.y = 15
	
	this.mochi = hp
	
	this.width  = 300
	this.height = 25
	
	--=========================================================
	-- 初期化
	--=========================================================
	this.init = function (self)

		this.mochi = hp

	end
	this:init()
	
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
			
		this.mochi = utils.Approach ( this.mochi, hp, 1 ) 
		
		if ( this.mochi < 0 ) then 
			this.mochi = 0
		end		
	end
	
	
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()
		
		local mochiLength = this.mochi * this.width / hpMax
		love.graphics.setColor(0.9, 1.0, 0.9, 0.8)
		love.graphics.rectangle ( "fill", this.x, this.y, mochiLength, this.height )
		
		-- 仮にマイナスになった場合、ゲージでは０と同じにする
		local hpToDisplay = hp
		if ( hpToDisplay < 0 ) then
			hpToDisplay = 0
		end
			
		local hpLength = hpToDisplay * this.width / hpMax
		love.graphics.setColor(0.4, 0.7, 0.4, 0.6)
		love.graphics.rectangle ( "fill", this.x, this.y, hpLength, this.height )
		

		love.graphics.setColor(0, 0, 0, 1.0, 0.6)
		love.graphics.rectangle ( "line", this.x, this.y, this.width, this.height )
		
		
		drawText ( ""..this.mochi.."/"..hpMax.."", this.x + 120, this.y + 5, {r=1,g=1,b=1}, fontSmall )

		
		love.graphics.setColor(r, g, b, a)
	end
	
	
		
	return this
end

