--=========================================================
-- ずんだ餅（回復）
--=========================================================
Zunda = {}
Zunda.new = function ( world, x, y )
	
	local this = {}
	
	this.x = x
	this.y = y
	this.world = world
	
	
	this.object = nil
	
	this.frameCount = 0
	
	

	--=========================================================
	-- デストラクト
	--=========================================================
	this.destruct = function (self)
		
		if ( this.object ~= nil ) then
			--this.object.body:destroy()
			destroyBodyReserveList [#destroyBodyReserveList + 1]  = this.object.body;
		end
	end
	
	--=========================================================
	-- 初期設定 
	--=========================================================
	this.putEntity = function (self)

		this.object = {}
		this.object.body = love.physics.newBody ( this.world, this.x, this.y, "static")
		this.object.body:setUserData ( {obj = this, name = "zunda"} )
	
		this.object.shape   = love.physics.newCircleShape ( 20 )
	
		this.object.fixture = love.physics.newFixture ( this.object.body, this.object.shape, 10) -- 3つめの値：dencity
		--this.object1.fixture:setFriction(1.0) -- 0.0 - 1.0
		--this.object1.fixture:setRestitution (0.3)
		
	end

	--=========================================================
	-- 位置セット
	--=========================================================
	this.setPosition = function(self, x, y)
		
		self.x = x
		self.y = y
		
		if ( this.object ~= nil ) then
			self.object.body:setX(x)
			self.object.body:setY(y)
		end
		
	end
	
	
	--=========================================================
	-- 更新
	--=========================================================
	this.update = function(self)
		
		if ( this.object ~= nil ) then
			
			self.x = self.object.body:getX()
			self.y = self.object.body:getY()
			

			
		else
			
			this.frameCount = this.frameCount + 1
			
			if ( this.frameCount > -1 ) then
				this:putEntity()
			end
			
		end
		
	end
	
	
	
	--=========================================================
	-- 描画
	--=========================================================
	this.draw = function(self)
		
		local r, g, b, a = love.graphics.getColor()

		if ( this.object ~= nil ) then
		
			
			love.graphics.draw ( zunda, this.x-32, this.y-32 )
			
			-- 当たり判定
			--love.graphics.setColor( 1,1,1 )
			--love.graphics.circle ( "line", this.object1.body:getX(), this.object1.body:getY(), this.object1.shape:getRadius() )
			
		else
			
			
		end


		love.graphics.setColor(r, g, b, a)
	end
	
	
		
	return this
end

